#!/bin/sh
+function err() {
+ echo 2>&1 "-E- $1"
+ exit 1
+}
+
+if [ ! -z "$3" ]; then
+ mountdir=$3
+fi
+
if [ -z "$mountdir" ]; then
echo >&2 '$mountdir must be set'
exit 1
export PATH=${rundir%%/}:/bin:/usr/bin:/sbin:/usr/sbin:/sw/bin
-if [ $# != 2 -o ! -d "$1" -o ! -d "$2" ]; then
- echo >&2 "Usage: $0 <source-directory> <target-directory>"
- echo >&2 "Example: $0 / /"
+if [ ! -d "$1" -o ! -d "$2" ]; then
+ echo >&2 "Usage: $0 <source-dir> <target-dir> [<mnt-dir>]"
+ echo >&2 " source-dir - directory on backup disks to restore from"
+ echo >&2 " target-dir - directory to restore files to"
+ echo >&2 " mnt-dir - directory where backup disk is mounted (optional)"
+ echo >&2 "Example: $0 / / /mnt/cdrom"
exit 1
fi
success=false
while ! $success; do
eject $device
+ [ $? != 0 ] && err "Cannot eject the disk. Drive is busy. Run lsof $mountdir to see why."
echo >&2 "Please insert backup disk: $date"
+ echo >&2 "Press Enter to continue"
read bogus
eject -t $device
if grep -q $date ${mountdir%%/}/backup-status.txt; then
success=true
else
- echo >&2 "This doesn't seem to be the right disk."
+ echo "This doesn't seem to be the right disk."
fi
done
rsyncopts="-W -H -S -l -p -t -g -o -0 --files-from=- --stats --progress"
- cat $dbfile | files-from-date.sh $date | rsync $rsyncopts ${mountdir%%/}/ ${2%%/}/
+ cat $dbfile | files-from-date.sh $date | grep -z -e "${1}" | rsync $rsyncopts ${mountdir%%/}/ ${2%%/}/
done